// watch all your go git repos
package main

import (
	"go.wit.com/dev/alexflint/arg"
	"go.wit.com/gui"
	"go.wit.com/lib/gadgets"
	"go.wit.com/lib/protobuf/forgepb"
	"go.wit.com/lib/protobuf/gitpb"
)

var me *autoType

type autoType struct {
	pp             *arg.Parser   // for parsing the command line args.  Yay to alexf lint!
	myGui          *gui.Node     // the gui handle itself
	releaseReasonS string        // = "gocui dropdown select"
	release        releaseStruct // notsure
	reposbox       *gui.Node     // notsure
	reposgrid      *gui.Node     // notsure
	reposgroup     *gui.Node     // notsure
	current        *gitpb.Repo   // tracks the next repo to publish
	found          *gitpb.Repos  // stores the list of repos to process things on
	done           []string      // gopaths for repos already published

	// this is the repo we are starting in
	// make sure it never changes so go.mod and go.sum are always there
	// 'go get' is called from here
	startRepo *gitpb.Repo

	// guireleaser window
	mainWindow *gui.Node
	mainBox    *gui.Node

	// our view of the repositories
	repos *repoWindow

	// your customized repo preferences and settings
	forge *forgepb.Forge

	// #### autotypist Global Build Options
	// what to change all the branches to
	// so, as a developer, you can move all the repos
	// to the 'devel' branch and then test a devel branch build
	// then switch back to your 'username' branch and do a build there
	// toMoveToBranch string

	// displays the preferred names used for the repo tree state
	// mainBranch  *gadgets.BasicCombobox
	// develBranch *gadgets.BasicCombobox
	// userBranch  *gadgets.BasicCombobox

	// this button will regenerate everyones go.mod & go.sum
	rerunGoMod *gui.Node

	// if checked, will stop trying to os.Exec() things after failure
	stopOnErrors *gui.Node

	// button to attempt to autorebuild
	autoRebuildButton *gui.Node

	// checkbox for --dry-run
	autoDryRun *gui.Node

	// checkbox for intermittent scanning
	scanEveryMinute *gui.Node

	// The current working directory
	autoWorkingPwd *gadgets.OneLiner

	// shows what directory being used as ~/go/src
	goSrcPwd *gadgets.OneLiner

	// button to download everything
	downloadEverythingButton *gui.Node

	// button to delete everythign ~/go/src & ~/go/pkg
	deleteGoSrcPkgB *gui.Node

	// button to set all repo branches to master
	setBranchesToMasterB *gui.Node

	// show the time it took to do a scan
	duration *gui.Node
}

/*
func (my *autoType) GoSrcPath() string {
	return my.goSrcPwd.String()
}
*/
